<?php
/**
 * $Horde: whups/graph.php,v 1.31 2005/01/03 14:35:43 jan Exp $
 *
 * Copyright 2002-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

@define('WHUPS_BASE', dirname(__FILE__));
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Reports.php';
require_once 'Horde/Graph.php';

$queues = Whups::permissionsFilter($whups->getQueues(), 'queue', PERMS_READ);
if (!count($queues)) {
    exit('no data available.');
}
if (($report = Util::getFormData('report')) === null ||
    empty($graphs[$report])) {
    exit('no report specified.');
}

$reporter = &new Whups_Reports($whups);
$data = $reporter->getDataSet($report);
if (is_a($data, 'PEAR_Error')) {
    Horde::fatal($data, __FILE__, __LINE__);
} elseif (!count($data)) {
    exit(_("There is no data for this graph."));
}

$graph = &new Horde_Graph(array('width' => 500, 'height' => 400, 'type' => 'png', 'imgType' => !empty($conf['image']['convert']) ? 'im' : 'gd', 'temp' => Horde::getTempDir()));
$graph->set('title', $graphs[$report]);
$graph->addXData(array_keys($data));
$graph->addChart('pie', array('dataset' => $graph->addYData(array_values($data))));
$graph->draw();
