<?php
/**
 * $Horde: whups/rss.php,v 1.10 2005/01/03 14:35:43 jan Exp $
 *
 * Copyright 2001-2005 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

define('WHUPS_BASE', dirname(__FILE__));
require_once WHUPS_BASE . '/lib/base.php';
require_once 'Horde/Template.php';

$ticket = Util::getFormData('id');
$ticket = preg_replace('|\D|', '', $ticket);
if (!$ticket) {
    exit;
}

// Get the ticket details first.
$details = $whups->getTicketDetails($ticket);
if (is_a($details, 'PEAR_Error')) {
    exit;
}

// Check permissions on this ticket.
if (!count(Whups::permissionsFilter(array($details['queue'] => ''), 'queue', PERMS_READ))) {
    exit;
}

$history = Whups::permissionsFilter($whups->getHistory($ticket),
                                    'comment', PERMS_READ);
foreach (array_keys($history) as $i) {
    $history[$i]['comment_text'] = htmlspecialchars($history[$i]['comment_text']);
    $history[$i]['date'] = date('Y-n-j', $history[$i]['timestamp']);
    $history[$i]['time'] = date('G:i', $history[$i]['timestamp']);
}

$template = &new Horde_Template();
$template->set('details', $details);
$template->set('history', $history, true);
$template->set('url', $whups->getTicketUrl($ticket));

header('Content-Type: text/xml');
echo $template->fetch(WHUPS_TEMPLATES . '/rss/ticket.rss');
