<?php

require_once 'Horde/UI/VarRenderer.php';
require_once 'Horde/UI/VarRenderer/html.php';

/**
 * $Horde: whups/templates/queryrenderer.inc,v 1.33 2004/12/19 01:34:00 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */
class QuerySetCurrentTypeRenderer extends Horde_Form_Renderer {

    function _renderForm(&$form, &$vars, $isActive)
    {
        global $whups, $whups_query;

        $droptext = Horde_UI_VarRenderer_html::_selectOptions($whups->getAllTypes(), $whups_query->getCurrentTicketType());
?>
<tr class="item0"><td>
 <table cellspacing="4" cellpadding="1" border="0">
  <tr class="item0">
   <td nowrap="nowrap"><b><?php echo _("Current Ticket Type") ?></b></td>
   <td><select name="ttype"><?php echo $droptext ?></select></td>
   <td><input class="button" type="submit" value="<?php echo _("Change") ?>" /></td>
   <td width="70%">&nbsp;</td>
  </tr>
 </table>
</td></tr>
<?php
    }

    function submit()
    {
    }

}

class QueryRenderer extends Horde_Form_Renderer {

    function QueryRenderer()
    {
        global $whups;
        $this->ticketTypes = $whups->getAllTypes();
    }

    function _renderForm(&$query, &$vars, $active)
    {
        $this->currentRow = 1;
        $this->isActive = $active;
        $this->currentPath = $vars->get('path');

        $this->_renderBegin();
        $query->walk($this, '_renderRow');
        $this->_renderEnd();
    }

    function edit(&$operations, $formname)
    {
?>
<tr><td class="item1"><table border="0" cellpadding="0" cellspacing="3"><tr><td>
 <select name="qaction" onchange="document.<?php echo $formname ?>.submit()">
<?php foreach ($operations as $value => $name) { ?>
  <option value="<?php echo $value ?>"><?php echo $name ?></option>
<?php } ?>
 </select>
</td></tr></table></td></tr>
<?php
    }

    function _renderBegin()
    {
    }

    function _renderBeginActive($name)
    {
        $this->_sectionHeader($name);
?><table border="0" width="100%" cellspacing="0" cellpadding="0"><?php
    }

    function _renderRow(&$more, &$path, $type, $ttype, $criterion, $cvalue, $operator, $value)
    {
        global $whups, $registry;

        $this->currentRow++;

        $pathstring = Query::pathToString($path);

        $depth = count($path);
        $class = "item" . ($this->currentRow % 2);

        switch ($type) {
        case QUERY_TYPE_AND: $text = _("And"); break;
        case QUERY_TYPE_OR:  $text = _("Or");  break;
        case QUERY_TYPE_NOT: $text = _("Not"); break;
        case QUERY_TYPE_CRITERION:
            $ttypeName = $this->ticketTypes[$ttype];
            $text = "[$ttypeName] ";

            switch ($criterion) {
            case CRITERION_ID:             $text .= _("Id"); break;
            case CRITERION_OWNERS:         $text .= _("Owners"); break;
            case CRITERION_GROUPS:         $text .= _("Groups"); break;
            case CRITERION_REQUESTER:      $text .= _("Requester"); break;
            case CRITERION_ADDED_COMMENT:  $text .= _("Commentor"); break;
            case CRITERION_COMMENT:        $text .= _("Comment"); break;
            case CRITERION_SUMMARY:        $text .= _("Summary"); break;

            case CRITERION_QUEUE:
                $text .= _("Queue");
                $value = $whups->getQueueName($value);
                break;

            case CRITERION_TYPE:
                $text .= _("Type");
                $value = $whups->getTypeName($value);
                break;

                // the value of the following depend on ttype
            case CRITERION_STATE:
                $text .= _("State");
                $value = $whups->getStateName($ttype, $value);
                break;

            case CRITERION_PRIORITY:
                $text .= _("Priority");
                $value = $whups->getPriorityName($ttype, $value);
                break;

            case CRITERION_ATTRIBUTE:
                $aname = $whups->getAttributeName($cvalue);
                $text .= sprintf("Attribute '%s'", $aname);
            }

            $text .= ' ';

            switch ($operator) {
            case OPERATOR_GREATER:         $text .= _("is greater than"); break;
            case OPERATOR_LESS:            $text .= _("is less than"); break;
            case OPERATOR_EQUAL:           $text .= _("is"); break;
            case OPERATOR_CI_SUBSTRING:    $text .= _("contains (case insensitive) substring"); break;
            case OPERATOR_CS_SUBSTRING:    $text .= _("contains (case sensitive) substring"); break;
            case OPERATOR_WORD:            $text .= _("contains the word"); break;
            case OPERATOR_PATTERN:         $text .= _("matches the pattern"); break;
            }

            $text .= " $value";
            break;

        default:
            $text = sprintf(_("Unknown node type %s"), $type);
            break;
        }

        // Stick vertical-align: middle; on everything to make it look
        // a little nicer.
        $fimgattrs = 'height="20" width="0" style="vertical-align: middle;"';
        $imgattrs = 'height="20" width="20" style="vertical-align: middle;"';
        $imgdir = $registry->getImageDir('horde');

        $space = '';
        $count = count($more);

        if ($count == 0) {
            // Always have at least one image to make sure all rows
            // are the same height.
            $space = Horde::img('tree/blank.png', '', $fimgattrs, $imgdir) . "\n";
        } else {
            for ($i = 0; $i < $count - 1; $i++) {
                if ($more[$i] == 1) {
                    $space .= Horde::img('tree/line.png', '|', $imgattrs, $imgdir) . "\n";
                } else {
                    $space .= Horde::img('tree/blank.png', '', $imgattrs, $imgdir) . "\n";
                }
            }
        }

        if ($count > 0) {
            if ($more[$count - 1] == 1) {
                $space .= Horde::img('tree/join.png', '+', $imgattrs, $imgdir) . "\n";
            } else {
                $space .= Horde::img('tree/joinbottom.png', '-', $imgattrs, $imgdir) . "\n";
            }
        }

        $extra  = ($this->isActive ? '' : ' disabled="disabled"');
        $extra .= ($pathstring == $this->currentPath ? ' checked="checked"' : '');
?>
 <tr><td class="<?php echo $class ?>">
  <input type="radio" name="path" style="vertical-align: middle;" value="<?php echo $pathstring ?>"<?php echo $extra ?>/>
  <?php echo $space ?>
  <span style="vertical-align: middle;"><?php echo $text ?></span>
 </td></tr>
<?php
    }

    function _renderEnd()
    {
    }

}
