<?php
/**
 * $Horde: whups/templates/searchresults.inc,v 1.44 2004/10/19 15:22:31 mdjukic Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */
class SearchResults {

    var $_title = '';

    function SearchResults($title = null)
    {
        if (!is_null($title)) {
            $this->_title = $title;
        }
    }

    /**
     * Display the set of tickets in $results. Also saves those
     * tickets into a cookie for back/forth search navigation.
     */
    function results(&$results, &$values)
    {
        global $prefs;

        $ids = array();
        foreach ($results as $info) {
            $ids[] = $info['id'];
        }
        $_SESSION['whups_tickets'] = $ids;
?>

<!-- Results Begin -->
<table width="100%" border="0" cellspacing="0" cellpadding="0">
 <tr>
  <td class="header" align="left" nowrap="nowrap"><?php echo $this->_title . ' (' . count($results) . ')' ?></td>
  <td class="header" align="right" nowrap="nowrap"><span class="smallheader">
    <?php if (Auth::getAuth() && count($results)): ?>
    <form action="<?php echo Horde::downloadUrl('report.html', null, Horde::applicationUrl('data.php')) ?>" method="post" name="datagen">
      <?php Util::pformInput() ?>
      <input type="hidden" name="ids" value="<?php echo implode(',', $ids) ?>" />
      <?php echo _("Save these results as: ") ?>
      <select name="template">
        <?php foreach (Whups::listTemplates('searchresults') as $name => $label): ?>
          <option value="<?php echo $name ?>"><?php echo htmlspecialchars($label) ?></option>
        <?php endforeach; ?>
      </select>
      <input type="submit" class="button" value="<?php echo _("Save") ?>" />
    </form>
  <?php endif; ?>
  </span></td>
 </tr>
</table>
<?php if (count($results)): ?>
<table class="headerbox" width="100%" border="0" cellspacing="0" cellpadding="1">
<?php
     $sortby  = $prefs->getValue('sortby');
     $sortdir = $prefs->getValue('sortdir');

     echo '<tr class="res_header">';
     foreach ($values as $name => $value) {
         $url = Horde::selfUrl();
         $url = Util::addParameter($url, 'formname', Util::getFormData('formname'));
         $url = Util::addParameter($url, 'action', Util::getFormData('action'));
         $url = Util::addParameter($url, 'id', Util::getFormData('id'));
         $url = Util::addParameter($url, 'queue', Util::getFormData('queue'));
         $url = Util::addParameter($url, 'sortby', $value);

         if ($sortby == $value) {
             $class = ' class="selected"';
             $revurl = Util::addParameter($url, 'sortdir', ($sortdir ? 0 : 1));
             $revimg = Horde::img($sortdir ? 'za.png' : 'az.png', _("Sort Direction"), '', $GLOBALS['registry']->getImageDir('horde'));
             $sortlink = Horde::link($revurl, sprintf(_("Sort by %s"), $name)) . $name . '&nbsp;' . $revimg . '</a> ';
         } else {
             $class = '';
             $rsortlink = '';
             $sortlink = Horde::link($url, sprintf(_("Sort by %s"), $name)) . $name . '</a> ';
         }

         echo '<th nowrap="nowrap" align="left"' . $class . '>' . $sortlink . '</th>';
     }
     echo '</tr>';

     foreach ($results as $info) {
         echo '<tr>';

         $url = Horde::applicationUrl(Util::addParameter('ticket/', 'id', $info['id']));

         foreach ($values as $name => $value) {
             $thevalue = isset($info[$value]) ? $info[$value] : '';

             if ($value == 'timestamp' || $value == 'date_assigned' || $value == 'date_resolved') {
                 $thevalue = Horde_Form_Type_date::getFormattedTime($thevalue, $prefs->getValue('report_time_format'), false);
             } elseif ($value == 'id' || $value == 'summary') {
                 $thevalue = Horde::link($url, isset($info['summary']) ? $info['summary'] : '') . "<b>$thevalue</b></a>";
             } elseif ($value == 'owners') {
                 if (!empty($info['owners'])) {
                     $owners = array();
                     foreach ($thevalue as $owner) {
                         $owners[] = Whups::formatUser($owner, false);
                     }
                     $thevalue = implode(', ', $owners);
                 }
             }

             $class = ($sortby == $value) ? 'linedRowSelectedCol' : 'linedRow';
             echo '<td class="' . $class . '">' . $thevalue . '</td>';
         }
     }
?>
</table>
<?php endif; ?>
<!-- Results End -->
<br />
<?php
    }

}
