<?php
/**
 * $Horde: whups/ticket/index.php,v 1.13 2005/01/03 14:35:46 jan Exp $
 *
 * Copyright 2001-2005 Robert E. Coyle <robertecoyle@hotmail.com>
 * Copyright 2001-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

@define('WHUPS_BASE', dirname(__FILE__) . '/..');
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Ticket.php';
require_once WHUPS_TEMPLATES . '/comment.inc';
require_once 'Horde/Variables.php';
require_once 'Horde/Text/Filter.php'; 

$ticket = &Whups::getCurrentTicket();
$vars = &Variables::getDefaultVariables();
$ticket->setDetails($vars);

$title = '[#' . $ticket->getId() . '] ' . $ticket->get('summary');
require WHUPS_TEMPLATES . '/common-header.inc';
require WHUPS_TEMPLATES . '/menu.inc';
require WHUPS_TEMPLATES . '/prevnext.inc';

$tabs = &Whups::getTicketTabs($vars);
$tabs->preserve('id', $ticket->getId());
echo $tabs->render();

$form = &new TicketDetailsForm($vars);
$form->addAttributes($whups->getAllTicketAttributesWithNames($ticket->getId()));

$RENDERER = &new Horde_Form_Renderer();
$RENDERER->beginInactive($title);
$RENDERER->renderFormInactive($form, $vars);
$RENDERER->end();

echo '<br />';

$COMMENT = &new Comment();
$COMMENT->begin(_("History"));
$history = Whups::permissionsFilter($whups->getHistory($ticket->getId()),
                                    'comment', PERMS_READ);
$chtml = array();
foreach ($history as $comment_values) {
    $chtml[] = $COMMENT->render(new Variables($comment_values));
}
if ($prefs->getValue('comment_sort_dir')) {
    $chtml = array_reverse($chtml);
}
echo implode('', $chtml);
$COMMENT->end();

require $registry->get('templates', 'horde') . '/common-footer.inc';
